/**
 * @file main.c
 * @author WHXY
 * @brief
 * @version 0.1
 * @date 2021-04-22
 *
 * @copyright Copyright (c) 2021
 *
 * 代码许可和免责信息
 * 武汉芯源半导体有限公司授予您使用所有编程代码示例的非专属的版权许可，您可以由此
 * 生成根据您的特定需要而定制的相似功能。根据不能被排除的任何法定保证，武汉芯源半
 * 导体有限公司及其程序开发商和供应商对程序或技术支持（如果有）不提供任何明示或暗
 * 含的保证或条件，包括但不限于暗含的有关适销性、适用于某种特定用途和非侵权的保证
 * 或条件。
 * 无论何种情形，武汉芯源半导体有限公司及其程序开发商或供应商均不对下列各项负责，
 * 即使被告知其发生的可能性时，也是如此：数据的丢失或损坏；直接的、特别的、附带的
 * 或间接的损害，或任何后果性经济损害；或利润、业务、收入、商誉或预期可节省金额的
 * 损失。
 * 某些司法辖区不允许对直接的、附带的或后果性的损害有任何的排除或限制，因此某些或
 * 全部上述排除或限制可能并不适用于您。
 *
*******************************************************************************/

/******************************************************************************
 * Include files
 ******************************************************************************/
#include "../inc/main.h"

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/
#define IWDT_DURATION 250 // 250ms
/******************************************************************************
 * Global variable definitions (declared in header file with 'extern')
 ******************************************************************************/

/******************************************************************************
 * Local type definitions ('typedef')
 ******************************************************************************/

/******************************************************************************
 * Local function prototypes ('static')
 ******************************************************************************/
void RCC_Configuration(void);
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void LCD_Configuration(void);

/******************************************************************************
 * Local variable definitions ('static')                                      *
 ******************************************************************************/

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/*****************************************************************************
 * Function implementation - global ('extern') and local ('static')
 ******************************************************************************/


/**
 * @brief
 * @return int32_t
 */
int32_t main(void)
{
    /* System Clocks Configuration */
    RCC_Configuration();

    /* GPIO Configuration */
    GPIO_Configuration();

    RCC_LSI_Enable();    // 启动LSI为LCD提供时钟
    LCD_Configuration();

    /* NVIC Configuration */
    NVIC_Configuration();
    LCD_Write(LCD_RAMRegister_0, 0x070f0f0f);

    while (1)
    {

    }
}

/**
  * @brief  Configures the different system clocks.
  * @param  None
  * @retval None
  */
void RCC_Configuration(void)
{
    /* 0. HSI使能并校准 */
//  RCC_HSI_OUT();
    RCC_HSI_Enable(RCC_HSIOSC_DIV6);

    /* 1. 设置HCLK和PCLK的分频系数　*/
    RCC_HCLKPRS_Config(RCC_HCLK_DIV1);
    RCC_PCLKPRS_Config(RCC_PCLK_DIV1);

    RCC_SystemCoreClockUpdate(8000000);

    /* 4. 配置外设时钟 */
    __RCC_GPIOF_CLK_ENABLE();

    __RCC_GPIOD_CLK_ENABLE();
    __RCC_GPIOC_CLK_ENABLE();
    __RCC_GPIOB_CLK_ENABLE();
    __RCC_GPIOA_CLK_ENABLE();
    __RCC_LCD_CLK_ENABLE();

}

/**
  * @brief  Configure the GPIO Pins.
  * @param  None
  * @retval None
  */
void GPIO_Configuration(void)
{
//  GPIO_InitTypeDef GPIO_InitStruct = {0};

//  /* 配置PA4为按键输入 */

//  GPIO_InitStruct.IT = GPIO_IT_FALLING;
//  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
//  GPIO_InitStruct.Pins = GPIO_PIN_1;


//  GPIO_Init(CW_GPIOA, &GPIO_InitStruct);
}

/**
  * @brief  Configure the nested vectored interrupt controller.
  * @param  None
  * @retval None
  */
void NVIC_Configuration(void)
{
    __disable_irq();
//  NVIC_EnableIRQ(WDT_IRQn);
//  NVIC_SetPriority(GPIOA_IRQn, 0);
//  NVIC_SetPriority(SysTick_IRQn, 1);
//  NVIC_EnableIRQ(GPIOA_IRQn);
//  __enable_irq();
}


void LCD_Configuration(void)
{
    LCD_InitTypeDef LCD_InitStruct = {0};

    LCD_InitStruct.LCD_Bias = LCD_Bias_1_3;
    LCD_InitStruct.LCD_ClockSource = LCD_CLOCK_SOURCE_LSI;
    LCD_InitStruct.LCD_Duty = LCD_Duty_1_4;
    LCD_InitStruct.LCD_ScanFreq = LCD_SCAN_FREQ_256HZ;
    LCD_InitStruct.LCD_VoltageSource = LCD_VoltageSource_External;

    LCD_Init(&LCD_InitStruct);     //基本配置
    // BTL004 LCD 对应的连接
    //PA12 COM3
    //PA11 COM2
    //PA10 COM1
    //PA09 COM0
    //PA08 SEG0
    //PC09 SEG1
    //PC08 SEG2
    //PC07 SEG3
    //PC06 SEG4
    //PD15 SEG32
    //PD14 SEG33
    //PD13 SEG34
    //PD12 SEG35
    //PD11 SEG36
    //PD10 SEG37
    //PD09 SEG38
    //PD08 SEG39
    //PB15 SEG5
    //PB14 SEG6
    //PB13 SEG7
    // 分配引脚
    LCD_COMConfig(LCD_COM0 | LCD_COM1 | LCD_COM2 | LCD_COM3, ENABLE);
    LCD_SEG0to23Config(0x0003E7FF, ENABLE);
    LCD_SEG24to27Config(LCD_SEG24|LCD_SEG25|LCD_SEG26|LCD_SEG27, ENABLE);    // Vbias为外部电路提供，需使能SEG24~SEG27作为VLCD1~4使用
    LCD_ChargeBumpCmd(ENABLE);    // Vbias由外部电容电路产生，必须打开电荷泵
    LCD_ChargeClockConfig(LCD_CHARGER_CLOCK_2KHZ);    //设置电荷泵的工作频率




    CW_LCD->RAM[0] = 0;
    CW_LCD->RAM[1] = 0;
    CW_LCD->RAM2 = 0;
    CW_LCD->RAM3 = 0;
    CW_LCD->RAM4 = 0;
    CW_LCD->RAM5 = 0;
    CW_LCD->RAM6 = 0;
    CW_LCD->RAM7 = 0;
    CW_LCD->RAM8 = 0;
    CW_LCD->RAM9 = 0;
    CW_LCD->RAM10 = 0;
    CW_LCD->RAM11 = 0;
    CW_LCD->RAM12 = 0;
    CW_LCD->RAM13 = 0;

    LCD_Cmd(ENABLE);
}


/******************************************************************************
 * EOF (not truncated)
 ******************************************************************************/
#ifdef USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
    /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
    /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
